Index: gsdl/trunk/perllib/strings.properties
===================================================================
--- gsdl/trunk/perllib/strings.properties	(revision 14251)
+++ gsdl/trunk/perllib/strings.properties	(revision 14252)
@@ -60,4 +60,5 @@
 
 # -- buildcol.pl --
+
 buildcol.archivedir:Where the archives live.
 
@@ -77,6 +78,4 @@
 
 buildcol.desc:PERL script used to build a greenstone collection from GA documents.
-
-buildcol.disable_OAI:Disable the OAI service for this collection. This flag applies to Greenstone 3 only.
 
 buildcol.faillog:Fail log filename. This log receives the filenames of any files which fail to be processed.
@@ -153,4 +152,5 @@
 downloadfrom.download_mode:The type of server to download from
 downloadfrom.download_mode.Web:HTTP  
+downloadfrom.download_mode.MediaWiki:MediaWiki website
 downloadfrom.download_mode.OAI: Open Archives Initiative 
 downloadfrom.download_mode.z3950:z3950 server
@@ -364,6 +364,4 @@
 mkcol.doing_replacements:doing replacements for %s
 
-mkcol.gs3mode:Make a Greenstone 3 collection. If this flag is present, the collectdir argument must also be provided.
-
 mkcol.long_colname:ERROR: The collection name must be less than 8 characters so compatibility with earlier filesystems can be maintained.
 
@@ -549,4 +547,5 @@
 GenericList.desc:A general and flexible list classifier with most of the abilities of AZCompactList, but with better Unicode, metadata and sorting capabilities.
 GenericList.metadata:Metadata fields used for classification. Use '/' to separate the levels in the hierarchy and ';' to separate metadata fields within each level.
+GenericList.partition_name_length:The length of the partition name; defaults to a variable length from 1 up to 3 characters, depending on how many are required to distinguish the partition start from its end. This option only applies when partition_type_within_level is set to 'constant_size'.
 GenericList.partition_size_within_level:The number of items in each partition (only applies when partition_type_within_level is set to 'constant_size').
 GenericList.partition_type_within_level:The type of partitioning done: either 'per_letter', 'constant_size', or 'none'.
@@ -863,4 +862,22 @@
 
 MARCXMLPlug.metadata_mapping_file:Name of file that includes mapping details from MARC values to Greenstone metadata names. Defaults to 'marctodc.txt' found in the site's etc directory.
+
+MediaWikiPlug.desc:Plugin for importing MediaWiki web pages
+
+MediaWikiPlug.show_toc: Add to the collection's About page the 'table of contents' on the MediaWiki website's main page. Needs to specify a Perl regular expression in toc_exp below to match the 'table of contents' section.
+
+MediaWikiPlug.delete_toc:Delete the 'table of contents' section on each HTML page. Needs to specify a Perl regular expression in toc_exp below to match the 'table of contents' section.
+
+MediaWikiPlug.toc_exp:A Perl regular expression to match the 'table of content'. The default value matches common MediaWiki web pages.
+
+MediaWikiPlug.delete_nav:Delete the navigation section. Needs to specify a Perl regular expression in nav_div_exp below.
+
+MediaWikiPlug.nav_div_exp:A Perl regular expression to match the navigation section. The default value matches common MediaWiki web pages. 
+
+MediaWikiPlug.delete_searchbox:Delete the searchbox section. Needs to specify a Perl regular expression in searchbox_div_exp below.
+
+MediaWikiPlug.searchbox_div_id:A Perl regular expression to match the searchbox section. The default value matches common MediaWiki web pages.
+
+MediaWikiPlug.remove_title_suffix_exp:A Perl regular expression to trim the extracted title. For example, \\s-(.+) will trim title contents after "-".
 
 MetadataCSVPlug.desc:A plugin for metadata in comma-separated value format. The Filename field in the CSV file is used to determine which document the metadata belongs to.
@@ -1049,4 +1066,10 @@
 
 BasDownload.desc:Base class for Download modules
+
+MediaWikiDownload.desc:A module for downloading from MediaWiki websites
+MediaWikiDownload.reject_filetype:Ignore url list, separate by comma, e.g.*cgi-bin*,*.ppt ignores hyperlinks that contain either 'cgi-bin' or '.ppt'
+MediaWikiDownload.reject_filetype_disp:Ignore url list, separate by comma
+MediaWikiDownload.exclude_directories:List of exclude directories (must be absolute path to the directory), e.g. /people,/documentation will exclude the 'people' and 'documentation' subdirectory under the currently crawling site.
+MediaWikiDownload.exclude_directories_disp:List of exclude directories, separate by comma
 
 OAIDownload.desc:A module for downloading from OAI repositories