Index: gsdl/trunk/macros/vietnamese2.dm
===================================================================
--- gsdl/trunk/macros/vietnamese2.dm	(revision 14119)
+++ gsdl/trunk/macros/vietnamese2.dm	(revision 14287)
@@ -727,5 +727,5 @@
 
 _textwhy_ [l=vi] {<p>QuÃ¡ trÃ¬nh gá»­i bÃ¡o cÃ¡o gáº·p sá»± cá» hoáº·c tháº¥t báº¡i.}  # Updated 8-Dec-2006 by vankhang
-_textextraforform_ [l=vi] {Báº¡n khÃŽng pháº£i Äiá»n vÃ o máº«u -- báº¥t ká»³ thÃŽng tin giÃºp Äá»¡.}
+_textextraforform_ [l=vi] {Báº¡n khÃŽng pháº£i Äiá»n vÃ o máº«u -- báº¥t ká»³ thÃŽng tin hÆ°á»ng dáº«n nÃ o.}  # Updated 19-Jul-2007 by kiemcm
 _textprivacybasic_ [l=vi] {<p>BÃ¡o cÃ¡o chá» chá»©a cÃ¡c thÃŽng tin vá» trang web Greenstone vÃ  ká»¹ thuáº­t mÃ  ngÆ°á»i sá»­ dá»¥ng Äang dÃ¹ng Äá» xem nÃ³ (vÃ  báº¥t cá»© thÃŽng tin mÃ  báº¡n cung cáº¥p).}  # Updated 13-Dec-2006 by nghiadoan
 _textstillsend_ [l=vi] {Báº¡n váº«n muá»n gá»­i bÃ¡o cÃ¡o nÃ y?}  # Updated 8-Dec-2006 by vankhang
@@ -803,4 +803,11 @@
 _textgtiselecttlc_ [l=vi] {Vui lÃ²ng chá»n ngÃŽn ngá»¯}  # Updated 5-Dec-2006 by vankhang
 
+#for status page
+_textgtiviewstatus_ [l=vi] {KÃ­ch chuá»t Äá» xem tÃ¬nh tráº¡ng dá»ch hiá»n táº¡i cho má»i ngÃŽn ngá»¯}  # Updated 19-Jul-2007 by kiemcm
+_textgtiviewstatusbutton_ [l=vi] {XEM TRáº NG THÃI}  # Updated 6-Jul-2007 by nghiadoan
+_textgtistatustable_ [l=vi] {Tráº¡ng thÃ¡i báº£n Äá»a hiá»n táº¡i cá»§a táº¥t cáº£ cÃ¡c ngÃŽn ngá»¯}  # Updated 6-Jul-2007 by nghiadoan
+_textgtilanguage_ [l=vi] {NgÃŽn ngá»¯}  # Updated 6-Jul-2007 by nghiadoan
+_textgtitotalnumberoftranslations_ [l=vi] {Tá»ng sá» má»¥c báº£n Äá»a}  # Updated 6-Jul-2007 by nghiadoan
+
 _textgtiselecttfk_ [l=vi] {Vui lÃ²ng chá»n má»t táº­p tin Äá» lÃ m viá»c vá»i}  # Updated 5-Dec-2006 by vankhang
 
@@ -812,4 +819,11 @@
 _textgtitutorials_ [l=vi] {BÃ i táº­p hÆ°á»ng dáº«n}  # Updated 5-Dec-2006 by nghiadoan
 _textgtigreenorg_ [l=vi] {Táº­p tin Greenstone.org}  # Updated 5-Dec-2006 by nghiadoan
+_textgtigs3core_ [l=vi] {Giao diá»n Greenstone3}  # Updated 6-Jul-2007 by nghiadoan
+
+#for greenstone manuals
+_textgtidevmanual_ [l=vi] {TÃ i liá»u hÆ°á»ng dáº«n phÃ¡t triá»n Greenstone}  # Updated 6-Jul-2007 by nghiadoan
+_textgtiinstallmanual_ [l=vi] {TÃ i liá»u hÆ°á»ng dáº«n cÃ i Äáº·t Greenstone}  # Updated 6-Jul-2007 by nghiadoan
+_textgtipapermanual_ [l=vi] {TÃ i liá»u hÆ°á»ng dáº«n táº¡o bá» sÆ°u táº­p sá» tá»« giáº¥y}  # Updated 6-Jul-2007 by nghiadoan
+_textgtiusermanual_ [l=vi] {TÃ i liá»u hÆ°á»ng dáº«n sá»­ dá»¥ng Greenstone}  # Updated 6-Jul-2007 by nghiadoan
 
 _textgtienter_ [l=vi] {Äá»ng Ãœ}  # Updated 5-Dec-2006 by vankhang
@@ -818,4 +832,5 @@
 _textgtidownloadtargetfile_ [l=vi] {Táº£i táº­p tin}  # Updated 5-Dec-2006 by vankhang
 _textgtiviewtargetfileinaction_ [l=vi] {Xem táº­p tin}  # Updated 5-Dec-2006 by vankhang
+_textgtitranslatefileoffline_ [l=vi] {Dá»ch tá»p tin nÃ y theo cÃ¡ch khÃŽng trá»±c tuyáº¿n}  # Updated 19-Jul-2007 by kiemcm
 
 _textgtinumchunksmatchingquery_ [l=vi] {Sá» cá»§a Äoáº¡n vÄn báº£n riÃªng biá»t thá»a vá»i cÃ¢u truy váº¥n}  # Updated 5-Dec-2006 by vankhang
@@ -825,4 +840,9 @@
 _textgtinumchunksrequiringtranslation_ [l=vi] {Báº£n dá»ch cÃ²n láº¡i}  # Updated 5-Dec-2006 by vankhang
 
+#for status page
+_textgtinumchunkstranslated2_ [l=vi] {sá» má»¥c Viá»t hoÃ¡ ÄÃ£ lÃ m}  # Updated 6-Jul-2007 by nghiadoan
+_textgtinumchunksrequiringupdating2_ [l=vi] {sá» má»¥c báº£n Äá»a yÃªu cáº§u cáº­p nháº­t}  # Updated 6-Jul-2007 by nghiadoan
+_textgtinumchunksrequiringtranslation2_ [l=vi] {sá» má»¥c báº£n Äá»a chÆ°a thá»±c hiá»n}  # Updated 6-Jul-2007 by nghiadoan
+
 _textgtienterquery_ [l=vi] {Nháº­p vÃ o má»t tá»« hoáº·c má»t thuáº­t ngá»¯ }  # Updated 5-Dec-2006 by vankhang
 _textgtifind_ [l=vi] {TÃ¬m kiáº¿m}  # Updated 5-Dec-2006 by nghiadoan
@@ -835,4 +855,15 @@
 
 _textgtitranslationfilecomplete_ [l=vi] {Táº­p tin nÃ y  ÄÆ°á»£c cáº­p nháº­t xong. CÃ³ thá» táº£i vá» táº­p tin nÃ y báº±ng liÃªn káº¿t bÃªn dÆ°á»i, vÃ  cÃ³ thá» thÃªm vÃ o bá» sÆ°u táº­p Greenstone trong tÆ°Æ¡ng lai.}  # Updated 5-Dec-2006 by vankhang
+
+_textgtiofflinetranslation_ [l=vi] {Báº¡n cÃ³ thá» dá»ch pháº§n nÃ y cá»§a Greenstone theo phÆ°Æ¡ng thá»©c khÃŽng trá»±c tuyáº¿n báº±ng cÃ¡ch sá»­ dá»¥ng tá»p Microsoft Excel riÃªng biá»t:
+
+<ol>
+<li>Táº£i xuá»ng <a href="_gwcgi_?a=gti&p=excel&e=_compressedoptions_">tá»p tin nÃ y </a>.
+<li>Má» ra báº±ng Microsoft Excel vÃ  lÆ°u láº¡i dÆ°á»i dáº¡ng Microsoft Excel workbook (.xls) format.
+<li>Nháº­p nhá»¯ng Äoáº¡n ÄÆ°á»£c dá»ch vÃ  o cÃ¡c há»p thoáº¡i cÃ³ sáºµn.
+<li>Khi káº¿t thÃºc viá»c dá»ch, gá»­i (e-mail) tá»p tin trÃªn MS Excel .xls Äáº¿n <a href="mailto:_gtiadministratoremail_">_gtiadministratoremail_</a>.
+</ol>
+}  # Updated 19-Jul-2007 by kiemcm
+
 
 