Index: /greenstone3/trunk/web/interfaces/default/transform/authen.xsl
===================================================================
--- /greenstone3/trunk/web/interfaces/default/transform/authen.xsl	(revision 14354)
+++ /greenstone3/trunk/web/interfaces/default/transform/authen.xsl	(revision 14355)
@@ -47,5 +47,5 @@
 		<td><xsl:if test="$un_s!=''">
 		    <xsl:if test="$asn!='' and $asn!='0'">
-		    User :  <xsl:value-of select="$un_s"/>
+		    <xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.username')"/>  :  <xsl:value-of select="$un_s"/>
 		    </xsl:if>
 		  </xsl:if></td>
@@ -56,12 +56,12 @@
 	  <div id="navbar">
 	    <ul id="navbarlist">
-	      <li><a href="{$library_name}">Greenstone home</a></li>
+	      <li><a href="{$library_name}"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.greenstone_home')"/></a></li>
 	      <li>
 		<xsl:choose>
 		  <xsl:when test="$asn!='' and $asn!='0' and $un_s!=''">
-		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.aup=ListUsers&amp;s1.asn={$asn}&amp;s1.uan=1&amp;s1.un={$un_s}&amp;s1.pw=">list users</a>
+		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.aup=ListUsers&amp;s1.asn={$asn}&amp;s1.uan=1&amp;s1.un={$un_s}&amp;s1.pw="><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.list_users')"/></a>
 	    </xsl:when>
 	      <xsl:otherwise>
-		<a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login">list users</a>
+		<a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.list_users')"/></a>
 	      </xsl:otherwise>
 	    </xsl:choose></li>
@@ -70,8 +70,8 @@
 		<xsl:choose>
 		  <xsl:when test="$asn!='' and $asn!='0' and $un_s!=''">
-		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.aup=AddUser&amp;s1.asn={$asn}&amp;s1.uan=1&amp;s1.un={$un_s}&amp;s1.pw=&amp;s1.umun=&amp;s1.umpw=&amp;s1.umgp=&amp;s1.umas=&amp;s1.umc=">add a new user</a> 
+		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.aup=AddUser&amp;s1.asn={$asn}&amp;s1.uan=1&amp;s1.un={$un_s}&amp;s1.pw=&amp;s1.umun=&amp;s1.umpw=&amp;s1.umgp=&amp;s1.umas=&amp;s1.umc="><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.add_a_new_user')"/></a> 
 		  </xsl:when>
 		  <xsl:otherwise>
-		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login">add a new user</a>
+		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.add_a_new_user')"/></a>
 		  </xsl:otherwise>
 		</xsl:choose>
@@ -81,8 +81,8 @@
 		<xsl:choose>
 		  <xsl:when test="$asn!='' and $asn!='0' and $un_s!=''">
-		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.aup=ModifyPassword&amp;s1.asn={$asn}&amp;s1.uan=1&amp;s1.un={$un_s}&amp;s1.pw=&amp;s1.umpw1=&amp;s1.umpw2=">change password</a>
+		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.aup=ModifyPassword&amp;s1.asn={$asn}&amp;s1.uan=1&amp;s1.un={$un_s}&amp;s1.pw=&amp;s1.umpw1=&amp;s1.umpw2="><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.change_password')"/></a>
 		  </xsl:when>
 		  <xsl:otherwise>
-		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login">change password</a>
+		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.change_password')"/></a>
 		  </xsl:otherwise>
 		</xsl:choose>
@@ -92,8 +92,8 @@
 		<xsl:choose>
 		  <xsl:when test="$un_s!='' and $asn!='' and $asn!='0'">
-		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login&amp;s1.un=&amp;s1.pw=">logout</a>
+		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login&amp;s1.un=&amp;s1.pw="><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.logout')"/></a>
 		  </xsl:when>
 		  <xsl:otherwise>
-		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login">login</a>
+		    <a href="{$library_name}?a=g&amp;rt=r&amp;sa=authen&amp;s=Authentication&amp;s1.asn=&amp;s1.aup=Login"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.login')"/></a>
 		  </xsl:otherwise>
 		</xsl:choose>
@@ -106,12 +106,9 @@
 	      <td>
 		<div id="content" align="center">
-		  <xsl:if test="$pro_action=''">
-		    <h2 align="left">User management</h2>
-		  </xsl:if>
 		  <!-- login -->
 		  <xsl:if test="$pro_action='Login'">
 		    <xsl:choose>
 		      <xsl:when test="$asn!='' and $asn!='0'">
-			<p align="left">Login successfully</p>
+			<p align="left"> <xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.login_successfully')"/></p>
 		      </xsl:when>
 		      <xsl:otherwise>