Index: /gli/trunk/src/org/greenstone/gatherer/cdm/Format4gs3.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/cdm/Format4gs3.java	(revision 14358)
+++ /gli/trunk/src/org/greenstone/gatherer/cdm/Format4gs3.java	(revision 14359)
@@ -44,6 +44,10 @@
     /** We keep a copy of the feature name */
     private String feature_name = null;
-    /** The format statement for this feature. */
+    /** The format statement for this feature (also contains classifier options if its a classifier), used by the format list on the top in GLI. */
     private String feature_format = null;
+    
+    /** The format statement for this feature (does not contain options in the front), displayed in the format editor at the bottom in GLI. 
+     *  If this format is not a classifier, feature_format==pure_format*/
+    private String pure_format = null;
     
     /** Wether this feature is about a classifier. The other way to check this is to see if feature_name starts with "CL" */
@@ -71,9 +75,11 @@
             classifier_options = classifier.toString();
 
-            feature_format = toOneLineFormat(XMLTools.getNodeText(element));
-            feature_format = classifier_options + " " + feature_format;
+                    
+            pure_format = toOneLineFormat(XMLTools.getNodeText(element));
+            feature_format = classifier_options + " " + pure_format;
         } else {
             feature_name = element.getAttribute(StaticStrings.NAME_ATTRIBUTE);
             feature_format = toOneLineFormat(XMLTools.getNodeText(element));
+            pure_format = feature_format;
         }
 
@@ -83,8 +89,10 @@
         this.feature_name = feature_name;
         this.feature_format = feature_format;
+        this.pure_format = feature_format;
+        
         is_classifier = feature_name.startsWith (Classifier.CLASSIFIER_PREFIX);
         
         element = CollectionConfiguration.createElement (StaticStrings.FORMAT_STR);
-        if(feature_name.startsWith(Classifier.CLASSIFIER_PREFIX)) {
+        if(is_classifier) {
             
             //Now get the options of the classifier
@@ -92,5 +100,5 @@
             //set the classifier_options string
             classifier_options = classifier.toString();
-
+            
             feature_format = classifier_options + " " + feature_format;
         } else {
@@ -98,5 +106,5 @@
         }
 
-        XMLTools.setNodeText(element, toOneLineFormat(feature_format));
+        XMLTools.setNodeText(element, toOneLineFormat(pure_format));
 
     }
@@ -138,5 +146,5 @@
     }
             
-    /** Method to translate this classes information into a line of text as you would expect on the format list panel
+    /** Method to translate this class information into a line of text as you would expect on the format list panel
      * @return A <strong>String</strong> containing the format command.
      */
@@ -152,6 +160,6 @@
             //update the classifier_options string
             classifier_options = classifier.toString();
-
-            feature_format = classifier_options + " " + toOneLineFormat(XMLTools.getNodeText(element));
+            pure_format = toOneLineFormat(XMLTools.getNodeText(element));
+            feature_format = classifier_options + " " + pure_format;
         }
     }    
@@ -159,4 +167,8 @@
         return toFormatedFormat(feature_format);
     }
+    public String getPureFormat() {
+        return toFormatedFormat(pure_format);
+    }
+    
     public Classifier getClassifier() {
         if(!isClassifier()) {
@@ -176,6 +188,14 @@
      */
     public void setFeatureFormat (String value) {
-        feature_format = value;
-        XMLTools.setNodeText(element, feature_format);
+        if(is_classifier) {
+          feature_format = classifier_options + " " + value;
+        } else {
+          feature_format = value;
+        }
+    }
+    public void setPureFormat (String value) {
+        pure_format = value;
+        setFeatureFormat (value);
+        XMLTools.setNodeText(element, pure_format);
     }
     public static String toOneLineFormat(String str) {