Index: gsdl/trunk/collect/modelcol/etc/collectionConfig.xml
===================================================================
--- gsdl/trunk/collect/modelcol/etc/collectionConfig.xml	(revision 14356)
+++ gsdl/trunk/collect/modelcol/etc/collectionConfig.xml	(revision 14386)
@@ -57,5 +57,23 @@
         <defaultIndex name="text"/>
         <format name="searchType">plain,form</format>
-        <format><gsf:template match="documentNode">       <td valign="top">             <gsf:link type="document">            <gsf:icon type="document"/>              </gsf:link>        </td>          </gsf:template>   </format>
+        <format><gsf:template match="documentNode">
+                <td valign="top">
+   	           <gsf:link type="document">
+                    <gsf:icon type="document"/>
+                   </gsf:link>
+                </td>
+ 	        <td>
+            	  <gsf:switch>
+                     <gsf:metadata name="Title" select="ancestors" separator=": "/>
+   	             <gsf:when test="exists">
+                      <gsf:metadata name="Title" select="ancestors" separator=": "/>:
+                     </gsf:when>
+                  </gsf:switch>
+	          <gsf:link type="document">
+                  <gsf:metadata name="Title"/>
+                  </gsf:link>
+              </td>
+              </gsf:template>
+           </format>
     </search>
     <import>
@@ -79,13 +97,87 @@
         <classifier name="AZList">
             <option name="-metadata" value="Title"/>
+            <format>
+	        <gsf:template match="classifierNode" mode="horizontal">
+  	          <gsf:link type="horizontal">
+                    <gsf:metadata name="Title"/>
+                  </gsf:link>
+               </gsf:template>
+            </format>
         </classifier>
         <classifier name="AZList">
             <option name="-metadata" value="Source"/>
-            <format><gsf:template match="classifierNode">        <br/>        <gsf:link type="classifier">           <gsf:metadata name="Title"/>         </gsf:link>      </gsf:template>       </format>
         </classifier>
-        <format><gsf:template match="classifierNode" mode="horizontal">        <gsf:link type="horizontal">           <gsf:metadata name="Title"/>         </gsf:link>      </gsf:template>          </format>
+        <format>
+             <gsf:template match="documentNode">
+    	         <td valign="top">
+ 	            <gsf:link type="document">
+                       <gsf:icon type="document"/>
+                    </gsf:link>
+                 </td>
+	         <td valign="top">
+                    <gsf:metadata name="srclink"/>
+  	            <gsf:choose-metadata>
+                       <gsf:metadata name="thumbicon"/>
+                       <gsf:metadata name="srcicon"/>
+                   </gsf:choose-metadata>
+                   <gsf:metadata name="/srclink"/>
+                 </td>
+ 	         <td valign="top">
+  	            <gsf:choose-metadata>
+                      <gsf:metadata name="dc.Title"/>
+                      <gsf:metadata name="exp.Title"/>
+                      <gsf:metadata name="Title"/>
+   	              <gsf:default>Untitled                                                                                            
+                     </gsf:default>
+                   </gsf:choose-metadata>
+	        <gsf:switch>
+                   <gsf:metadata name="Source"/>
+           	     <gsf:when test="exists">
+                       <br/>
+                    	<i>(<gsf:metadata name="Source"/>)</i>
+                     </gsf:when>
+                </gsf:switch>
+                </td>
+             </gsf:template>
+	  <gsf:template match="classifierNode">
+    	      <td valign="top">
+	           <gsf:link type="classifier">
+                   <gsf:icon type="classifier"/>
+                   </gsf:link>
+              </td>
+ 	      <td valign="top">
+             <gsf:metadata name="srclink"/>
+ 	     <gsf:choose-metadata>
+               <gsf:metadata name="thumbicon"/>
+               <gsf:metadata name="srcicon"/>
+               </gsf:choose-metadata>
+             <gsf:metadata name="/srclink"/>
+              </td>
+	     <td valign="top">
+	        <gsf:choose-metadata>
+                <gsf:metadata name="dc.Title"/>
+                <gsf:metadata name="exp.Title"/>
+                <gsf:metadata name="Title"/>
+	        <gsf:default>Untitled</gsf:default>
+             </gsf:choose-metadata>
+ 	     <gsf:switch>
+                 <gsf:metadata name="Source"/>
+          	    <gsf:when test="exists">
+                    <br/><i>(<gsf:metadata name="Source"/>)</i>
+                 </gsf:when>
+             </gsf:switch>
+             </td>
+             </gsf:template>
+	     <gsf:template match="classifierNode" mode="horizontal">
+      	          <gsf:link type="horizontal">
+                  <gsf:metadata name="Title"/>
+                  </gsf:link>
+              </gsf:template>
+        </format>
     </browse>
     <display>
-        <format><gsf:template match="documentcontent">     </gsf:template>    <gsf:option name="TOC" value="true"/>         </format>
+        <format><gsf:template match="documentcontent"></gsf:template>
+                 <gsf:option name="TOC" value="true"/>
+        </format>
     </display>
     <replaceListRef id="gs2-standard"/>